Subject: bug#29533: Fwd: [Feature Request] ERC: let erc-join-channel support to select channels from history or a defined list

From: stardiviner <[email-masked]>
Date: Wed, 13 May 2020 19:37:06 +0800

Stefan Kangas <[email-masked]> writes:

> stardiviner <[email-masked]> writes:
>
>> Hi, Stefan, I'm afraid I can't submit patch soon. This task is not
>> priority on my tasks now. Because this patch is long time agon, I barely
>> use ERC recently. I still keep this task waited, when I got time to deal
>> with it, and finished it, I will send it here. Sorry about this.
>
> Thank you.  There is no particular rush, but it would be good to get the
> patch merged eventually.

I have a question, I have code like bellowing:

#+begin_src emacs-lisp
;;; original code
(defun erc-join-channel (channel &optional key)
  "Join CHANNEL.

If `point' is at the beginning of a channel name, use that as default."
  (interactive
   (list
    (let ((chnl (if (looking-at "\\([&#+!][^ \n]+\\)") (match-string 1) ""))
          (table (when (erc-server-buffer-live-p)
                   (set-buffer (process-buffer erc-server-process))
                   erc-channel-list)))
      (completing-read "Join channel: " table nil nil nil nil chnl))
    (when (or current-prefix-arg erc-prompt-for-channel-key)
      (read-from-minibuffer "Channel key (RET for none): " nil))))
  (erc-cmd-JOIN channel (when (>= (length key) 1) key)))

;;===============================================================================

(defcustom erc-join-channels-alist nil
  "Alist of channels to select when you join channels.

Every element in the alist has the form (SERVER . CHANNELS).
SERVER is a regexp matching the server, and channels is the
list of channels to join.

If the channel(s) require channel keys for joining, the passwords
are found via auth-source.  For instance, if you use ~/.authinfo
as your auth-source backend, then put something like the
following in that file:

machine irc.example.net login \"#fsf\" password sEcReT

Customize this variable to set the value for your first connect.
Once you are connected and join and part channels, this alist
keeps track of what channels you are on, and will join them
again when you get disconnected.  When you restart Emacs, however,
those changes are lost, and the customization you saved the last
time is used again."
  :group 'erc-join
  :type '(repeat (cons :tag "Server"
                       (regexp :tag "Name")
                       (repeat :tag "Channels"
                               (string :tag "Name")))))

(setq erc-join-channels-alist
      '((".*\\.freenode.net" ; "freenode.net"
         "#emacs"
         "#org-mode"
         "#lisp"
         "#clojure"
         "#clojure-beginners"
         "#archlinux"
         "#swift-lang"
         "#docker"
         "#hackerrank")))

(defun erc-join-channel-select (args)
  "Select a channel to join from alist of channels to."
  (let ((channel (completing-read
                  "Select a channel: "
                  (cdr (assoc
                        (completing-read "Select a server: "
                                         (mapcar 'car erc-join-channels-alist))
                        erc-join-channels-alist)))))
    (setq args (list channel))))

(advice-add 'erc-join-channel :filter-args 'erc-join-channel-select)

(advice-remove 'erc-join-channel 'erc-join-channel-select)
#+end_src

When I press [C-c C-j] (erc-join-channel), the advice is added on function,
but seems not working. Don't know why, do you have any clue?

> Best regards,
> Stefan Kangas

- -- 
[ stardiviner ]
       I try to make every word tell the meaning that I want to express.

       Blog: https://stardiviner.github.io/
       IRC(freenode): stardiviner, Matrix: stardiviner
       GPG: F09F650D7D674819892591401B5DF1C95AE89AC3